.TH show_scig_nodes 1 "September 1995" "Scilab Group" "Scilab function"
.so ../sci.an
.SH NAME
show_scig_nodes - highlights a set of nodes
.SH CALLING SEQUENCE
.nf
show_scig_nodes(nodes,[sup])
.fi
.SH PARAMETERS
.TP 6
nodes
: row vector of node numbers
.TP 4
sup
: string, superposition flag
.SH DESCRIPTION
\fVshow_scig_nodes\fR highlights the set of nodes \fVnodes\fR of the
displayed graph in the current Metanet window.
If the optional argument \fVsup\fR is equal to the string 'sup',
the highlighting is superposed on the previous one.

By default, this function works in asynchronous mode (see \fVmetanet_sync\fR).
.SH EXAMPLE
.nf
scigraph(graph=SCI+'/demos/metanet/mesh100.graph',...
	wdim=[500,500],wpdim=[500,500]);
for i=1:3:100,xpause(100000), show_scig_nodes([i]); end;
for i=1:3:100, show_scig_nodes([i],'sup'); end;
show_scig_nodes([]);
.fi
.SH SEE ALSO
metanet_sync, show_arcs
